<template>
  <div>
    <!-- Domain -->
    <CoscineFormGroup
      :mandatory="true"
      label-for="Domain"
      :label="$t('resourceType.gitlab.domainLabel')"
      :is-loading="isLoading"
      type="input"
    >
      <b-form-input
        id="Domain"
        :model-value="resource?.type?.options?.gitLab?.repoUrl"
        :placeholder="$t('resourceType.gitlab.domain')"
        readonly
        :disabled="true"
      />
    </CoscineFormGroup>

    <!-- GitLab Project ID -->
    <CoscineFormGroup
      :mandatory="true"
      label-for="ProjectId"
      :label="$t('resourceType.gitlab.projectIdLabel')"
      :is-loading="isLoading"
      type="input"
    >
      <b-form-input
        id="ProjectId"
        :model-value="resource?.type?.options?.gitLab?.projectId"
        :placeholder="$t('resourceType.gitlab.projectId')"
        readonly
        :disabled="true"
      />
    </CoscineFormGroup>

    <!-- GitLab Project -->
    <CoscineFormGroup
      :mandatory="true"
      label-for="Project"
      :label="$t('resourceType.gitlab.projectLabel')"
      :is-loading="isLoading"
      type="input"
    >
      <b-form-input
        id="Project"
        :model-value="
          gitlabInformation.project
            ? gitlabInformation.project.name
            : $t('resourceType.gitlab.projectNotValidated')
        "
        :placeholder="$t('resourceType.gitlab.project')"
        readonly
        :disabled="true"
      />
    </CoscineFormGroup>

    <!-- Access Token -->
    <CoscineFormGroup
      :mandatory="true"
      label-for="AccessToken"
      :label="$t('resourceType.gitlab.accessTokenLabel')"
      :is-loading="isLoading"
      type="input"
      info
    >
      <b-form-input
        id="AccessToken"
        v-model="v$.gitlabInformation.accessToken.$model"
        :state="
          v$.gitlabInformation.accessToken.$dirty
            ? !v$.gitlabInformation.accessToken.$error &&
              isGitlabConnectionSuccessful
            : null
        "
        :placeholder="$t('resourceType.gitlab.accessToken')"
        required
      />
      <div class="invalid-tooltip">
        {{ $t("resourceType.gitlab.accessTokenInvalidTooltip") }}
      </div>
      <template #popover>
        {{ $t("resourceType.gitlab.accessTokenInfoPopover") }}
        <b-link
          :href="$t('resourceType.gitlab.accessTokenInfoPopoverUrl').toString()"
          target="_blank"
          >{{ $t("default.help") }}
        </b-link>
      </template>
    </CoscineFormGroup>

    <CoscineFormGroup>
      <b-button
        variant="primary"
        class="d-inline-block"
        :disabled="
          !(
            v$.gitlabInformation.domain.$dirty &&
            !v$.gitlabInformation.domain.$invalid &&
            v$.gitlabInformation.accessToken.$dirty &&
            !v$.gitlabInformation.accessToken.$invalid
          )
        "
        @click="verifyDomainAndToken(false)"
      >
        {{ $t("resourceType.gitlab.verifyConnection") }}
      </b-button>
    </CoscineFormGroup>

    <!-- GitLab Reference -->
    <CoscineFormGroup
      :mandatory="true"
      label-for="GitLabReference"
      :label="$t('resourceType.gitlab.referenceLabel')"
      :is-loading="isLoading"
      type="input"
    >
      <multiselect
        id="GitLabReference"
        v-model="v$.gitlabInformation.branch.$model"
        :options="gitlabBranches ?? []"
        :multiple="false"
        :hide-selected="false"
        label="name"
        track-by="name"
        :show-labels="false"
        :placeholder="$t('resourceType.gitlab.reference')"
        select-label=""
        selected-label=""
        deselect-label=""
        :disabled="!(isGitlabConnectionSuccessful && gitlabInformation.project)"
        @update:modelValue="setSelectedGitLabReference"
      >
        <template #noResult>
          {{ $t("page.createResource.multiselect.noResults") }}
        </template>
        <template #noOptions>
          {{ $t("page.createResource.multiselect.noOptions") }}
        </template>
      </multiselect>

      <template #hint>
        <span
          v-if="gitlabInformation.branch && !gitlabInformation.branch.canPush"
          class="text-danger"
        >
          {{
            $t("resourceType.gitlab.cantPush", {
              branch: gitlabInformation.branch?.name,
            })
          }}
        </span>
      </template>
    </CoscineFormGroup>
  </div>
</template>

<script lang="ts" setup>
import useResourceStore from "../../../store";
import useNotificationStore from "@/store/notification";
import type { GitlabInformation } from "@/modules/resource/types";

import { useVuelidate, type ValidationArgs } from "@vuelidate/core";
import { integer, minValue, required, url } from "@vuelidate/validators";
import { isNumber } from "lodash";
import type {
  GitlabBranchDto,
  GitlabProjectDto,
  ResourceForUpdateDto,
  ResourceTypeOptionsForUpdateDto,
} from "@coscine/api-client/dist/types/Coscine.Api";

import { useI18n } from "vue-i18n";
const i18n = useI18n();

const resourceForUpdate = defineModel<ResourceForUpdateDto>({ required: true });

const resourceStore = useResourceStore();
const notificationStore = useNotificationStore();

const gitlabInformation = ref({
  domain: "",
  accessToken: "",
  project: null,
  branch: null,
} as GitlabInformation);

const state = reactive({
  gitlabInformation,
});

const rules = {
  gitlabInformation: {
    domain: { required, url },
    accessToken: { required },
    project: { required, minValue: minValue(1), integer },
    branch: { required },
  } as ValidationArgs<GitlabInformation>,
};

const v$ = useVuelidate(rules, state);

const gitlabProjects = ref([] as GitlabProjectDto[] | null | undefined);
const gitlabBranches = ref([] as GitlabBranchDto[] | null | undefined);
const isGitlabConnectionSuccessful = ref(null as boolean | null);
const isLoading = ref(false);

const resource = computed(() => {
  return resourceStore.currentResource;
});

watch(
  () => gitlabInformation.value.accessToken,
  () => {
    if (
      v$.value.gitlabInformation.accessToken.$dirty &&
      !v$.value.gitlabInformation.accessToken.$invalid
    ) {
      // Set the information inside the resource
      const resourceTypeOptionsForUpdateDto = {
        gitlabResourceTypeOptions: {
          accessToken: gitlabInformation.value.accessToken,
        },
      } as ResourceTypeOptionsForUpdateDto;
      resourceForUpdate.value.resourceTypeOptions =
        resourceTypeOptionsForUpdateDto;
    }
  },
);

const verifyDomainAndToken = async (suppressNotifications: boolean) => {
  gitlabProjects.value = await resourceStore.getGitlabAllProjects(
    gitlabInformation.value.domain,
    gitlabInformation.value.accessToken,
  );
  v$.value.gitlabInformation.$touch();
  if (
    gitlabProjects.value &&
    !v$.value.gitlabInformation.domain.$invalid &&
    !v$.value.gitlabInformation.accessToken.$invalid
  ) {
    isGitlabConnectionSuccessful.value = true;

    gitlabInformation.value.project =
      gitlabProjects.value.find(
        (p) => p.id === resource.value?.type?.options?.gitLab?.projectId,
      ) ?? null;
    await setSelectedGitLabProject();
    if (gitlabBranches.value) {
      gitlabInformation.value.branch =
        gitlabBranches.value.find(
          (r) =>
            r.name ===
            resourceForUpdate.value.resourceTypeOptions
              ?.gitlabResourceTypeOptions?.branch,
        ) ?? null;
      setSelectedGitLabReference();
    }

    // Set the information inside the resource
    const resourceTypeOptionsForManipulationDto = {
      gitlabResourceTypeOptions: {
        repoUrl: gitlabInformation.value.domain,
        accessToken: gitlabInformation.value.accessToken,
        branch: gitlabInformation.value.branch?.name,
        projectId: gitlabInformation.value.project?.id,
        tosAccepted: true,
      },
    } as ResourceTypeOptionsForUpdateDto;
    resourceForUpdate.value.resourceTypeOptions =
      resourceTypeOptionsForManipulationDto;

    if (!suppressNotifications) {
      // Post success notification
      notificationStore.postNotification({
        title: i18n
          .t("resourceType.gitlab.verificationToast.success.title")
          .toString(),
        body: i18n
          .t("resourceType.gitlab.verificationToast.success.body")
          .toString(),
      });
    }
  } else {
    isGitlabConnectionSuccessful.value = false;
    resourceForUpdate.value.resourceTypeOptions = {};
    if (!suppressNotifications) {
      // Post failure notification
      notificationStore.postNotification({
        title: i18n
          .t("resourceType.gitlab.verificationToast.failure.title")
          .toString(),
        body: i18n
          .t("resourceType.gitlab.verificationToast.failure.body")
          .toString(),
        variant: "warning",
      });
    }
  }
};

const setSelectedGitLabProject = async () => {
  if (
    gitlabInformation.value.project &&
    isNumber(gitlabInformation.value.project.id)
  ) {
    gitlabBranches.value = await resourceStore.getGitlabBranchesForProject(
      gitlabInformation.value.project.id,
      gitlabInformation.value.domain,
      gitlabInformation.value.accessToken,
    );
  }
};

const setSelectedGitLabReference = () => {
  // Set the information inside the resource
  if (
    gitlabInformation.value.branch &&
    gitlabInformation.value.branch.name &&
    resourceForUpdate.value.resourceTypeOptions?.gitlabResourceTypeOptions
  ) {
    resourceForUpdate.value.resourceTypeOptions.gitlabResourceTypeOptions.branch =
      gitlabInformation.value.branch.name;
  }
};

const initTabContent = async () => {
  isLoading.value = true;
  if (
    resource.value?.type?.options?.gitLab?.repoUrl &&
    resourceForUpdate.value.resourceTypeOptions?.gitlabResourceTypeOptions
  ) {
    // A resource type has been selected, but the resource's properties are unset. Set the values.
    gitlabInformation.value.domain =
      resource.value.type.options?.gitLab.repoUrl;
    gitlabInformation.value.accessToken =
      resourceForUpdate.value.resourceTypeOptions.gitlabResourceTypeOptions.accessToken;
    await verifyDomainAndToken(true);
    v$.value.gitlabInformation.$validate();
  }
  isLoading.value = false;
};

initTabContent();
</script>
